=== test/connector_c/CMakeLists.txt ===

tarantool_client("tt" tt.c)
tarantool_client("update" update.c)
