=== debian/changelog ===
tarantool (1.4.5+20120503-2) unstable; urgency=low

  * Add librt to linklist (fix FTBFS with Debian/kFreeBSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 04 May 2012 09:27:04 +0400

tarantool (1.4.5+20120503-1) unstable; urgency=low

  * New upstream snapshot.
  * Add Priority for sources.
  * Add libtarantool* packages that weren't be packaged earlier: upstream
    renamed them, now we have no conflicts with the other debian packages.
  * Add libncurses5-dev into Build-Depends.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 03 May 2012 17:35:18 +0400
