=== third_party/CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,10 @@
 
 add_library (misc STATIC crc32.c proctitle.c qsort_arg.c ${misc_opt_sources})
 if (NOT TARGET_OS_DEBIAN_FREEBSD) 
-	if (TARGET_OS_FREEBSD)
-	  set_source_files_properties(proctitle.c PROPERTIES
-	       COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
-	endif()
+    if (TARGET_OS_FREEBSD)
+      set_source_files_properties(proctitle.c PROPERTIES
+           COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
+    endif()
 endif()
 
 add_subdirectory(coro)
@@ -20,11 +20,18 @@
 
 macro (luajit_build)
     set (luajit_buildoptions BUILDMODE=static)
+    set (luajit_copt ${CCOPT})
     if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
-        set (luajit_buildoptions ${luajit_buildoptions} CCOPT=-O0)
         set (luajit_buildoptions ${luajit_buildoptions} CCDEBUG=-ggdb)
+        set (luajit_copt ${luajit_copt} -O1)
         set (luajit_buildoptions ${luajit_buildoptions} XCFLAGS='-DLUA_USE_APICHECK -DLUA_USE_ASSERT')
+    else ()
+        set (luajit_copt ${luajit_copt} -O2)
     endif()
+    if (NOT HAVE_UNWIND_H)
+        set (luajit_copt ${luajit_copt} -I${PROJECT_SOURCE_DIR}/third_party/compat)
+    endif()
+    set (luajit_buildoptions ${luajit_buildoptions} CCOPT="${luajit_copt}")
     set (luajit_buildoptions ${luajit_buildoptions} Q='')
     if (${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
         add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/third_party/luajit/src/libluajit.a
