=== mod/box/CMakeLists.txt ===
--- 
+++ 
@@ -34,5 +34,5 @@
 set_source_files_properties(memcached.m
     PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")
 
-tarantool_module("box" tuple.m index.m tree.m box.m box.lua.c box_lua.m
-    memcached.m memcached-grammar.m)
+tarantool_module("box" tuple.m index.m tree.m space.m port.m request.m
+    txn.m box.m box.lua.c box_lua.m memcached.m memcached-grammar.m)
