## tarantool 1.4.6+20120524

=== debian/changelog ===
tarantool (1.4.6+20120524-1) unstable; urgency=low

  * Fix version number.
  * Fix tarantool_instance: user could not to define 'file_descriptors'

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 24 May 2012 12:57:27 +0400
